Subject: [rmcat] ECN support for UDP (was RE: [rtcweb] Catching up on diffserv markings)

From: Ingemar Johansson S <[email-masked]>
Date: Fri, 23 Oct 2015 08:40:26 +0000

A followup on the ECN discussion :

Congestion control wise (RMCAT) both NADA and SCReAM support ECN in the specification. In addition MTSI (3GPP SA4) support ECN in the specification.
In SCReAM, the support is not fully implemented in running code but he feedback is in place and the additional amount of code needed to get ECN support is very small. The latest specification however explains the ECN support, the behavior is very similar to RFC3168 as SCReAM is a self-clocked protocol.
The current snag is that the sockets need to be modified to give access to the two ECN bits. More specifically, what is needed is to be able to set the two ECN bits and to read the same two ECN bits in the IP header, this is also stated in section 9 in RFC6679 . Here I believe that one can easily spend more time discussing the good and bad sides of adding ECN support to the socket interface than it actually takes to implement it ☺ .

Network wise, I guess the support for ECN for UDP is a matter of configuration, but if one look from strict radio (LTE) perspective it does not really matter if it is UDP or TCP over IP, it is treated the same, thus the strategy for ECN marking should be the same and should preferably follow the guidelines in RFC7567.

/Ingemar

From: Colin Perkins [mailto:[email-masked]]
Sent: den 22 oktober 2015 11:14
To: Pal Martinsen (palmarti)
Cc: [email-masked]; [email-masked]; [email-masked]; Dave Taht; [email-masked]
Subject: Re: [rmcat] [rtcweb] Catching up on diffserv markings

On 22 Oct 2015, at 08:48, Pal Martinsen (palmarti) <[email-masked]<mailto:[email-masked]>> wrote:

On 21 Oct 2015, at 18:10, Harald Alvestrand <[email-masked]<mailto:[email-masked]>> wrote:

Den 21. okt. 2015 17:51, skrev Dave Taht:

I unsubscribed from rmcat and rtcweb groups a while back after I got
overloaded, and appear.in started working so well, (for both ipv6 and
ipv4! I use it all day long now!), to focus on finishing up the new
"cake" qdisc/shaper/aqm/QoS system, among other things.

http://www.bufferbloat.net/projects/codel/wiki/CakeTechnical

Cake is now entering the testlab, and among other things, it has
support for the diffserv markings discussed in the related, now
concluded dart wg, but in ways somewhat different from that imagined
there. We have not got any good code in our testbeds yet to test
videoconferencing behavior, and we could use some, although it does
look like we can drive firefox with some remote control stuff with a
fixed video playback now....

Five questions:

1) Has anyone implemented or tested putting voice and video on two
different 5-tuples in any running code out there?

All VC systems I know of except WebRTC-based ones do it, AFAIK.
It’s putting them on the same that's unusual.

That sounds like the world I am living in as well.

2) How about diffserv markings in general? Do any browsers or webrtc
capable software support what was discussed way back when?

I know Hangouts did something like that internally, on the controlled
network. But not according to spec.

3) Were diffserv marking changes eventually allowed on the same 5-tuple?

Yes, with caveats. draft-ietf-tsvwg-rtcweb-qos has the table.

4) Did the ECN support that was originally in one draft or another
ever make it into any running code?

I don't know. I think we lost it from the docs.
(yea, apple plans to turn on ecn universally in their next OS!)
So how would ECN work on UDP? I do not think the necessary bits from the IP header are available for the application to do anything. I do think Linux supports this, have not tested.

And what about the network, would it support UDP when setting the ECN bits? Probably a configuration related problem if not supported.

RFC 6679 describes how to use ECN with RTP on UDP, although as you say there are implementation difficulties on some platforms. I’m not sure whether there are implementations.

5)  What else did I miss in the past year I should know about?

For TCP and SCTP congestion controllers, we're back to one DSCP marking
per flow, and resetting the congestion control state if DSCP marking
changes.

There is a new ICE wg. It was created so “network people” could participate without the overhead of listening to the SDP related discussions. (https://datatracker.ietf.org/wg/ice/charter/)

.-.
Pål-Erik

Feel free to contact me off list if these have already been discussed.
I have totally lost track of the relevant drafts.

They're not finished still :-)

Sincerely,

Dave Täht
I just lost five years of my life to making the edge
of the internet, and, wifi better.
And, now... the FCC wants to make my work illegal
for ordinary people to install.
https://www.gofundme.com/savewifi

_______________________________________________
rtcweb mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/rtcweb

_______________________________________________
rtcweb mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/rtcweb

_______________________________________________
rtcweb mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/rtcweb

--
Colin Perkins
https://csperkins.org/